#include"Image.h"

#include<stdio.h>
#include<algorithm>
#include<string>
#include<vector>
#include<math.h>
#include<assert.h>
#include<random>

using namespace std;
using lf = double;

using namespace IMAGE;

struct vec2 {
	lf x, y;
	vec2() {
		x = y = 0;
	}
	vec2(lf x, lf y):x(x),y(y) {}

	vec2 operator +(const vec2& z) {
		return vec2(x + z.x, y + z.y);
	}
	vec2 operator -(const vec2& z) {
		return vec2(x - z.x, y - z.y);
	}
	vec2 operator *(const lf& z) {
		return vec2(x * z, y * z);
	}
	lf operator *(const vec2& z) {
		return x * z.x + y * z.y;
	}
	lf operator %(const vec2& z) {
		return x * z.y - y * z.x;
	}
	void normalize() {
		lf dd = sqrt(x * x + y * y);
		x /= dd;
		y /= dd;
	}
};
Image img;
Image number[10];
Image imagepile;
Image grass;
int width = 480;
int height = 160;
lf pileswidth = 90;
lf pilesx = (width - pileswidth * 5) * 0.5;
lf pileunit = 42;
lf pilesy = 20;
lf pilescale;

mt19937 rnd;
int nextint(int s, int t) {
	return (int)(rnd() % (t - s + 1)) + s;
}

void inil()
{
	int i, j, k;
	img.setsize(width, height);

	for (i = 0; i < 10; i++) {
		char xxx[99];
		sprintf(xxx, "numbers/%d.png", i);
		number[i].Load(xxx);
		//number[i].set_transparency_color(255, 255, 255, 0);
		for (int j = 0; j < number[i].h; j++) {
			for (int k = 0; k < number[i].w; k++) {
				int id = (j * number[i].w + k);
				int z = number[i].data[id * 4 + 0];
				number[i].data[id * 4 + 0] = 0;
				number[i].data[id * 4 + 1] = 0;
				number[i].data[id * 4 + 2] = 0;
				number[i].data[id * 4 + 3] = 255 - z;
			}
		}
	}
	imagepile.Load("piles.png");
	imagepile.set_transparency_color(255, 255, 255, 0);

	pilescale = pileswidth / imagepile.w;
}
int a[9] = { 1,2,3,2,1 };
int n, m;
void build_data() {
	int i, j, k;
	n = 5;
	m = 3;
}
void draw_pile() {
	img.clean();
	for (int i = 0; i < n; i++) {
		int k = a[i];
		lf cx = pilesx + pileswidth * i;
		lf cy = height - (pilesy + pileunit * k);
		img.draw_image(cx, cy, cx + pileswidth, cy + imagepile.h * pilescale, imagepile);
	}
	img.draw_image(0.0, height - pilesy - pileunit * 0.5, width, height, grass);
}
void draw_range(int si, int ei) {
	lf offset = pileunit * 0.25;
	lf rangeradius = 3.0;
	{
		int k = a[si];
		lf cx = pilesx + pileswidth * si;
		lf cy = height - (pilesy + pileunit * k);
		img.draw_line(cx, cy, cx, cy - offset, rangeradius,0.0, 0.0, 0.0);
	}
	for (int i = si; i <= ei; i++) {
		int k = a[i];
		lf cx = pilesx + pileswidth * i;
		lf cy = height - (pilesy + pileunit * k);
		img.draw_line(cx, cy - offset, cx + pileswidth, cy - offset, rangeradius,0.0, 0.0, 0.0);
	}
	{
		int k = a[ei];
		lf cx = pilesx + pileswidth * (ei+1);
		lf cy = height - (pilesy + pileunit * k);
		img.draw_line(cx, cy, cx, cy - offset, rangeradius, 0.0, 0.0, 0.0);
	}
	{
		int k = a[si];
		lf cx = pilesx + pileswidth * (si + ei + 1) * 0.5;
		lf cy = height - (pilesy + pileunit * k) - offset * 1.5;

		img.draw_triangle(
			cx, cy,
			cx + pileswidth * 0.25, cy - offset,
			cx - pileswidth * 0.25, cy - offset,
			0.0, 0.0, 0.0
		);
		img.draw_rectangle(
			cx - pileswidth * 0.125, cy - offset * 3,
			cx + pileswidth * 0.125, cy - offset + 1,
			0.0, 0.0, 0.0
		);
		Image num = number[5];
		for (int i = 0; i < num.h; i++) {
			for (int j = 0; j < num.w; j++) {
				int id = i * num.w + j;
				int z = num.data[id * 4 + 0];
				for (int k = 0; k < 3; k++) {
					num.data[id * 4 + k] = 255 - num.data[id*4 + k];
				}
			}
		}
		lf numoffset = offset * 0.5;
		img.draw_image(
			cx - pileswidth * 0.125 - numoffset * 2, cy - offset * 3 - numoffset,
			cx + pileswidth * 0.125 + numoffset * 2, cy - offset * 2 + numoffset * 3,
			num
		);

	}
}
void build_grass() {
	grass.setsize(width, pilesy + pileunit * 0.5);
	int i, j, k;
	grass.clean(0, 0, 0);
	grass.mSamplingMode = SamplingModeType::SAMPLING_3x3;

	int tn = 100;
	lf gscale = (lf)width / tn;
	for (i = 0; i <= tn+2; i++) {
		lf sx = i * gscale;
		lf sy = grass.h * 0.5;
		grass.draw_triangle(
			sx + nextint(-gscale, gscale), sy - nextint(grass.h * 0.3, grass.h * 0.5),
			sx + nextint(gscale, 2*gscale), sy + nextint(grass.h * 0.5, grass.h * 0.8),
			sx - nextint(gscale, 2*gscale), sy + nextint(grass.h * 0.5, grass.h * 0.8),
			nextint(0.0, 100.0) / 255.0,
			nextint(150, 255) / 255.0,
			nextint(0.0, 100.0) / 255.0,
			nextint(50, 100) / 100.0
			);
	}

	for (i = 0; i < grass.h; i++) {
		for (j = 0; j < grass.w; j++) {
			int id = i * grass.w + j;
			if (grass.data[id * 4 + 1] < 120) {
				int zz = grass.data[id * 4 + 1];
				grass.data[id * 4 + 3] = zz * 2;
			}
		}
	}
}
int main() {
	int i, j, k;
	inil();
	build_grass();
	grass.Save("grass.png");

	build_data();
	img.mSamplingMode = SamplingModeType::SAMPLING_3x3;
	draw_pile();
	img.Save("00_base_piles.png");
	a[2] = 2;
	draw_pile();
	draw_range(1, 3);
	img.Save("01_opt_piles.png");
}